﻿using System;
using System.Collections.Generic;
using System.Text;
//step1. reference nmodbuspc.dll, and using the namespaces.
using Modbus.Device;      //for modbus master
using System.Net;         //for tcp client
using System.Net.Sockets;

namespace input_status
{
    class Program
    {
        static void Main(string[] args)
        {
            // connect to Modbus TCP Server
            string ipAddress = "127.0.0.1"; //Input WISE IP
            int tcpPort = 502;
            byte slaveID = 1;
            TcpClient tcpClient = new TcpClient(ipAddress, tcpPort);

            // create Modbus TCP Master by the tcp client
            //document->Modbus.Device.Namespace->ModbusIpMaster Class->Create Method
            ModbusIpMaster master = ModbusIpMaster.CreateIp(tcpClient);

            // read the input status 20~29 (10020~10029, DI ch0 ~ ch9) of the WISE module.
            //document->Modbus.Device.Namespace->ModbusMaster Class->ReadInput Method            
            ushort startAddress = 20;
            ushort numOfPoints = 10;
            master.Transport.ReadTimeout = 1000;
            try
            {
                bool[] status = master.ReadInputs(slaveID, startAddress, numOfPoints);
                for (int index = 0; index < status.Length; index++)
                    Console.WriteLine(string.Format("DI[{0}] = {1}", index, status[index]));
            }
            catch (Exception ex)
            {
                Console.WriteLine(ex.Message);
            }

            Console.WriteLine("Press enter to exit....");
            Console.ReadLine();
        }
    }
}

